(*
 * SNU 4541.664A Program Analysis
 * Main program driver
 *)
open Program
open D

let src = ref ""
let opt_pp = ref false
let opt_intp = ref false
let opt_cintp = ref false

let main () = 
  Arg.parse
    [ ("-pp", Arg.Unit (fun _ -> opt_pp := true), "print pgm");
      ("-intp", Arg.Unit (fun _ -> opt_intp := true), "d interpreter");
      ("-cintp", Arg.Unit (fun _ -> opt_cintp := true), "d collecting interpreter")]
    (fun x -> src := x)
    ("Usage : " ^ (Filename.basename Sys.argv.(0)) ^ " [-option] [filename] ");
  let lexbuf = Lexing.from_channel (if !src = "" then stdin else open_in !src) in
  let pgm = (Parser.program Lexer.start lexbuf) in
  if !opt_pp then (
	  let _ =print_endline "=== Printing Input Program ===" in
	  pp pgm
  )
  else if !opt_intp then (
    let result = D.dintp pgm in
    print_endline (string_of_mem result)
  )
  else if !opt_cintp then (
    let results = D.dcintp pgm in
    print_endline (string_of_col results)
  )
  else
    print_endline "Please provide one of options! (-pp, -intp, -cintp)"
  
let _ = main ()
